/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 2000
 *	NetBSD/pc98 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _I386_BUSIO_USER_H_
#define _I386_BUSIO_USER_H_

#define	BUS_SPACE_USER_SPACE
#include <machine/bus.h>
typedef	bus_size_t *bus_space_tag_t;
typedef	u_long bus_space_handle_t;

#include <machine/slot_device.h>

u_int8_t bus_space_read_1 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t));
void bus_space_write_1 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t,\
	u_int8_t));
u_int16_t bus_space_read_2 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t));
void bus_space_write_2 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t,\
	u_int16_t));
void bus_space_read_multi_2 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t, u_int16_t *, bus_size_t));
void bus_space_write_multi_2 __P((bus_space_tag_t,\
	bus_space_handle_t,\
	bus_size_t, u_int16_t *, bus_size_t));

#endif /* _I386_BUSIO_USER_H_ */
